/*
    Fichier messages.c
    Auteur Bernard Chardonneau

    Logiciel libre, droits d'utilisation prciss en franais
    dans le fichier : licence.fr

    Traductions des droits d'utilisation dans les fichiers :
    licence.de , licence.en , licence.es , licence.it
    licence.nl , licence.pt , licence.eo , licence.eo-utf


    Bibliothque de fonctions utilisant des fichiers de donnes
    pour dialoguer avec l'utilisateur dans sa langue.

    Le contenu de cette bibliothque pour l'instant rudimentaire
    sera complt en phase d'internationalisation de Libremail
    (versions 1.9.x devant aboutir  la version 2.0).
*/

#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
//#include <string.h>
#include "messages.h"
#include "szchemin.h"



/* variables globales au source */

char *ncom;  // nom de (ou chemin d'accs ) la commande en cours d'excution
char repert_com [szchemin] = ""; // rpertoire o est implante cette commande



/* mmorise le nom ou le chemin d'accs de la commande en cours d'excution */

void memcom (char *arg0)
{
    ncom = arg0;
}


/* retourne le nom ou le chemin d'accs de la commande en cours d'excution */
char *nomcom ()
{
    return (ncom);
}


/* retourne le nom du rpertoire o est la commande en cours d'excution */
char *dircom ()
{
    int derslash;  // position du dernier slash rencontr dans ncom
    char *path;    // variable d'environnement PATH
    char chemcom [szchemin]; // chemin d'accs complet  la commande
    int  i, j;     // indices pour parcourir et recopier ncom et path


    // si le nom de ce rpertoire n'est pas encore mmoris
    if (! *repert_com)
    {
        // initialisation
        derslash = 0;
        i = 0;

        // recopier ncom dans repert_com et chercher la position du dernier /
        while (ncom [i])
        {
            if (ncom [i] == '/')
                derslash = i;

            repert_com [i++] = ncom [i];
        }

        // on ne conserve dans repert_com que le nom du rpertoire
        repert_com [derslash] = '\0';

        // si aucun nom de rpertoire n'a t trouv
        if (! *repert_com)
        {
            // on va tester les chemins de la variable d'environnement PATH
            path = getenv ("PATH");

            i = 0;

            do
            {
                j = 0;

                // recopier l'un de ces chemins
                while (path [i] != ':' && path [i])
                {
                    repert_com [j++] = path [i++];
                }

                // terminer la chaine de caractres
                repert_com [j] = '\0';

                // gnrer le chemin d'accs  la commande
                sprintf (chemcom, "%s/%s", repert_com, ncom);
            }
            // termin si ce chemin d'accs est le bon
            while (access (chemcom, 0) != 0 && path [i++]);
        }
    }

    // retourner le nom du rpertoire
    return (repert_com);
}
